{ package CODEV;
	# ONO Hiroki onohiroki@cup.com 
	# open source project
	use strict;
	use warnings;
	sub read_lens_data_seq {
		my $data = shift;
		my @lines = split m{\n},$data;
		my $agf_glass_catalog;
		my $cv_glass_catalog;
		if (@_) {
			$agf_glass_catalog = shift;
			$cv_glass_catalog = shift;
		}
		if ((ref $agf_glass_catalog) ne 'GlassCagalog') {
			my $dumped;
			$dumped = `cat ~/Dropbox/work/perl-lens/Lib/GLASS/CVGLASS`;
			$cv_glass_catalog = GlassCatalog->new_with_dumped_data($dumped);
			$dumped = `cat ~/Dropbox/work/perl-lens/Lib/GLASS/AGFGLASS`;
			$agf_glass_catalog = GlassCatalog->new_with_dumped_data($dumped);
		}
		my $cv_glassname_hash = $agf_glass_catalog->create_cv_glassname_hash;
		my $lens = Lens->new('lens');
		my $lens_glass_catalog = $lens->glasscatalog;
		my $private_glass_w = Wavelength->new;
		my $ref_wavelength = Wavelength->new->by_names('d');
		my $wavelength = $ref_wavelength;
		my @glass = ();
		my @zoom_data = ();
		my @wl = ();
		my $vg1 = q{};
		my $vg2 = q{};
		my $vg3 = q{};
		my $vg4 = q{};

		$lens->set_etc("Read CODE V .SEQ Lens Data");
		my %surface = (
			Number=>-1,
			Radius=>0,
			Thickness=>0,
			Index=>1,
			Abbe=>0,
			Glass=>Air->get,
			RefractMode => 'Refract',
			Glassname=>q{},
			Stop=>q{},
			AspericConstant=>[undef],
			CIR=>0,
			);
		
		my @lines2 = ();	
		while (@lines) {
			my $tmp = shift @lines;
			if ($tmp =~ s/&\s*$//) {
				my $next = shift @lines;
				$tmp = "$tmp $next";
			}
			push (@lines2, $tmp);
		}
		
		foreach (@lines2) {
			s/\x0D|\x0A//gi; 
			
			if ( /PRV/ .. /END/ ) {
				#print STDERR "\n PRV:",$_;
				my $line = $_;
				
				if ($line =~ m/^\s+PWL\s+(.*)/) {
					my @w = split /\s+/, $1;
					$private_glass_w->by_wavelengths(@w);
				}
				else {
					if ($line =~ m/\'/){
						$line =~ s/^\s+//;
						my @g = split /\s+/, $line;
						my @wl;
						my $w_names = $private_glass_w->names_array;

						push (@wl,@$w_names);
						my $glass_name = shift @g;
						$glass_name =~ s/\'//g;
						my %glass;
						while (@g) {
							my $i = shift @g;
							my $wavelength_name = shift @wl;
							my $wavelength = $private_glass_w->wavelength($wavelength_name);
							$glass{$wavelength_name} = [$wavelength,$i];
						}
						my $glass = Glass->new($glass_name);
						$glass->indeces(\%glass);
						my $nd = $glass->index('d');
						my $nc = $glass->index('C');
						my $nf = $glass->index('F');
						$glass->set_nd($nd) if ($nd);
						if ($nd && $nc && $nf) {
							my $vd = ($nd -1)/($nf - $nc);
							$glass->set_vd($vd);
						}
						$lens_glass_catalog->add_glass($glass);
					}
				}
			}
			
			$lens->set_etc($1) if (m/RDM;LEN\s+(.*)/);
			$lens->set_etc($_) if (m/DIM\s+/);
			$lens->set_etc($_) if (m/REF\s+/);
			$lens->set_etc($_) if (m/WTW\s+/);
			$lens->set_etc($_) if (m/INI\s+/);
			#$lens->set_etc($_) if (m/XAN\s+/);
			#$lens->set_etc($_) if (m/YAN\s+/);
			$lens->set_etc($_) if (m/WTF\s+/);
			$vg1 = $1 if (m/^\s*VUY\s+(.*)/);
			$vg2 = $1 if (m/^\s*VLY\s+(.*)/);
			$vg3 = $1 if (m/^\s*VUX\s+(.*)/);
			$vg4 = $1 if (m/^\s*VLX\s+(.*)/);
			$lens->set_etc($_) if (m/VLY\s+/);
			
			$lens->set_name($1) if (m/TITLE\s+\'([^\']*)/);
			$lens->set_entrance_pupil_diameter ($1) if (m/EPD\s+([^\s]+)/);
			
			$lens->set_f_number ($1) if (m/FNO\s+([^\s]+)/);
			
			$surface{CIR} = ($1) if (m/CIR\s+[A-Za-z]+\s+([^\s]+)/);
			
			if (m/^\s*YAN\s+(.+)/) {
				my @f = split /\s+/,$1;
				$lens->set_y_field_angle(@f);
			}
			elsif (m/^\s*YRI\s+(.+)/) {
				my @f = split /\s+/,$1;
				$lens->set_y_field_image_height(@f);
			}
			elsif (m/^\s*YIM\s+(.+)/) {
				
				my @f = split /\s+/,$1;
				$lens->set_y_field_paraxial_image_height(@f);
			}
			elsif (m/^\s*YOB\s+(.+)/) {
				my @f = split /\s+/,$1;
				$lens->set_y_field_object_height(@f);
			}
			
			if (m/^\s*XAN\s+(.+)/) {
				my @f = split /\s+/,$1;
				$lens->set_s_field_angle(@f);
			}
			elsif (m/^\s*XRI\s+(.+)/) {
				my @f = split /\s+/,$1;
				$lens->set_s_field_image_height(@f);
			}
			elsif (m/^\s*XIM\s+(.+)/) {
				
				my @f = split /\s+/,$1;
				$lens->set_s_field_paraxial_image_height(@f);
			}
			elsif (m/^\s*XOB\s+(.+)/) {
				my @f = split /\s+/,$1;
				$lens->set_s_field_object_height(@f);
			}
			
			$surface{Glassname} = $1 if (m/GCH\s+(.*)/);
			
			if (m/WL\s+(\S)+/) {
				@wl = qw/$_/;
			}
			if (m/\s*STO\s*$/) {
				$surface{Stop} = 'yes';
			}
			if (m/\s*WL\s+/) {
				my @wl = split /\s+/, $_;
				shift @wl;
				$wavelength = Wavelength->new->by_wavelengths(@wl);
				#map {print " w:$_ "} @wl;
				#$wavelength->list;
				$lens->wavelength($wavelength);
			}
			if (m/\s*REF\s+(.+)/){
				$ref_wavelength = $wavelength->copy_by_order($1);
			}
			my $asp_const = $surface{AspericConstant};
			$$asp_const[1] = $1 if (m/^\s*K\s+([^;\s]+)/);
			$$asp_const[2] = $1 if (m/^\s*A\s+([^;\s]+)/);
			$$asp_const[3] = $1 if (m/^\s*B\s+([^;\s]+)/);
			$$asp_const[4] = $1 if (m/^\s*C\s+([^;\s]+)/);
			$$asp_const[5] = $1 if (m/^\s*D\s+([^;\s]+)/);
			$$asp_const[6] = $1 if (m/^\s*E\s+([^;\s]+)/);
			$$asp_const[7] = $1 if (m/^\s*F\s+([^;\s]+)/);
			$$asp_const[8] = $1 if (m/^\s*G\s+([^;\s]+)/);
			$$asp_const[9] = $1 if (m/^\s*H\s+([^;\s]+)/);
			$$asp_const[10] = $1 if (m/^\s*J\s+([^;\s]+)/);
			
			if ( m/S[OI]*\s+-?\d+\.?\d*e?\d*\s+-?\d+\.?\d*e?-?\d*/ || m/^GO\s*$/ ) {
				if ($surface{Number} >= 0) {
					my $glass;
					if ($surface{Glass}) {
						$glass = $surface{Glass};
					}
					else{
						my $glassname = q{};
						my $glassmaker = q{};
						if ($surface{Glassname} ne q{}){
							$glassname = $surface{Glassname};
							if ($glassname =~ m/([^_]+)_([A-Z]+)/) {
								$glassname  = $1;
								$glassmaker = $2;
							}
						}
						else {
							my $num = $surface{Number};
							$glassname = "Glass$num";
						}
						$glass = Glass->new($glassname,$glassmaker,$surface{Index},$surface{Abbe});
					}
					if ($surface{Index} && $surface{Index} != 1){
						$lens->add_surface($surface{Radius},$surface{Thickness},$glass);
					}
					else {
						$lens->add_surface($surface{Radius},$surface{Thickness});
					}
					$lens->set_stop_surface($surface{Number}) if ($surface{Stop});
					$lens->surface->set_refract_mode('Reflect') if ($surface{RefractMode} eq 'Reflect');
					if (@$asp_const > 1) {
						if (@$asp_const < 2) {
							$$asp_const[0] = 'Conic';
						}
						else {
							$$asp_const[0] = 'Aspheric';
						}
						#print join "\nASP:", @$asp_const;
						my $sur = $lens->last_surface->change_as_aspherical->set_aspheric_params($asp_const);
						my $num = $lens->last_surface->number;
						$lens->replace_surface($num,$sur);
						$surface{AspericConstant} = [undef];
						#print "\n";
					}
					if ($surface{CIR}) {
						$lens->last_surface->set_semidiameter($surface{CIR});
						$surface{CIR} = 0;
					}
					$surface{RefractMode} = 'Refract';
					$surface{Stop} = q{};
				}
				$surface{Glassname} = q{};
				$surface{Number} = $surface{Number}+1;
			}
			if (m/S[OI]*\s+(-?\d+\.?\d*e?\d*)\s+(-?\d+\.?\d*e?-?\d*)\s+(-?\d+)\.(-?\d\d)(\d*)/){
				$surface{Radius} = $1;
				$surface{Thickness} = $2;
				$surface{Index} = sprintf "1.%s", $3;
				$surface{Abbe} = sprintf "%s.%s", $4, $5;
				$surface{Glass} = undef;
			}
			elsif (m/S[OI]*\s+(-?\d+\.?\d*e?\d*)\s+(-?\d+\.?\d*e?-?\d*)\s+([^_]+)_([\w]+)/){
				$surface{Radius} = $1;
				$surface{Thickness} = $2;
				my $glass_name = $3;
				my $glass_maker = $4;
				my $glass;
				if (exists $$cv_glassname_hash{$glass_name.q{_}.$glass_maker}) {
					$glass = $agf_glass_catalog->glass($$cv_glassname_hash{$glass_name.q{_}.$glass_maker},$glass_maker);
				}
				else {
					$glass = $cv_glass_catalog->glass($glass_name,$glass_maker);
				}
				$surface{Glass} = $glass;
				$surface{Index} = $glass->{Index};
				$surface{Abbe} = $glass->{Abbe};
			}
			elsif (m/S[OI]*\s+(-?\d+\.?\d*e?\d*)\s+(-?\d+\.?\d*e?-?\d*)\s+\'([^\']+)\'/){
				$surface{Radius} = $1;
				$surface{Thickness} = $2;
				my $glass_name = $3;
				my $glass;
				$glass = $agf_glass_catalog->glass($glass_name);
				$glass = $cv_glass_catalog->glass($glass_name) if ((ref $glass) eq 'NotFound');
				$glass = $lens_glass_catalog->glass($glass_name) if ((ref $glass) eq 'NotFound');
				$surface{Glass} = $glass;
				$surface{Index} = $glass->{Index};
				$surface{Abbe} = $glass->{Abbe};
			}
			elsif (m/S[OI]*\s+(-?\d+\.?\d*e?\d*)\s+(-?\d+\.?\d*e?-?\d*)/){
				$surface{Radius} = $1;
				$surface{Thickness} = $2;
				$surface{Index} = 1;
				$surface{Abbe} = 0;
				$surface{Glass} = undef;
			}
			$surface{RefractMode} = 'Reflect' if (m/ REFL/);

			if (m/ZOO\s+THI\s+S(.*)/) {
				push(@zoom_data,$1);
			}
		}
		foreach(@zoom_data){
			my @params = split(/\s+/,$_);
			$lens->set_zoomed_thickness_of_surface(@params);
		}
		if ($vg1) {
			my @v = split /\s+/,$vg1;
			map {$_ = (1 - $_)} @v;
			$lens->set_vignetting1(@v);
		}
		if ($vg2) {
			my @v = split /\s+/,$vg2;
			map {$_ =(1 - $_)} @v;
			$lens->set_vignetting2(@v);
		}
		if ($vg3) {
			my @v = split /\s+/,$vg3;
			map {$_ =(1 - $_)} @v;
			$lens->set_vignetting3(@v);
		}
		if ($vg4) {
			my @v = split /\s+/,$vg4;
			map {$_ =(1 - $_)} @v;
			$lens->set_vignetting4(@v);
		}
		$lens->wavelength($wavelength);
		$lens->reference_wavelength($ref_wavelength);
		$lens->set_indeces;
		return $lens;
		
	}
	sub read_lens_data_seq_file {
		my $file = shift;
		my $lens;
		if ( -e $file ){
			open(IN, "<$file");
			my @lines = <IN>;
			my $data;
			$data = $data.$_ foreach (@lines);
			close(IN);
			$lens = read_lens_data_seq($data);
		}
		else {
			print STDERR "\nERROR: can't find.\n";
			$lens = Lens->new;
		}
		return $lens;
	}
	
	sub read_glass_macro_data {
		my $self = shift;
		my $cv_glass_macro_data_catalog = GlassCatalog->new;
		my ($cat, $glass, $index, $vvalue) = (q{},q{},1,0);
		my @cv_glass_macro_data_files = <*.dat>;
		foreach my $dat (@cv_glass_macro_data_files) {
			open DATFILE, "<$dat";
			my $head = <DATFILE>;
			next if ($head !~ m/Catalog	Glass	Index	V-value	NF-NC	DPF	Price	Avail	Bubble	Stain/);
			while (<DATFILE>) {
				if (m/(\w+)\t([^\s]+)\t([^\s]+)\t([^\s]+)/) {
					$cat = $1;
					$glass = $2;
					$index = $3;
					$vvalue = $4;
					#printf "%10s %10s %10.6f 10.6f\n",$cat, $glass, $index, $vvalue;
					$cv_glass_macro_data_catalog->add_new_glass($glass,$cat,$index,$vvalue);
				}
			}
		}
		#$cv_glass_macro_data_catalog->list;
		delete($$cv_glass_macro_data_catalog{q{}});
		return $cv_glass_macro_data_catalog;
	}
	1;
}