{ package Glass;
	# ONO Hiroki onohiroki@cup.com 
	# http://www.opensource.org/licenses/bsd-license
	# Copyright (c) 2011, ONO Hiroki onohiroki@cup.com 
	# All rights reserved.
	use strict;
	use warnings;
	sub new {
		my $class = shift;
		my $name = shift;
		my $maker = shift;
		my $index = shift;
		my $abbe = shift;
		my $etc = \@_ ;
		my $self = {
			Name => $name,
			Maker => $maker,
			Index => $index,
			Abbe => $abbe,
			Coefficient => [],
			Etc => $etc,
		};
		bless $self, $class;
	}

	sub copy {
		my $class = shift;
		my $glass = shift;
		my $glassname = $glass->name;
		$glassname = "copy_of_$glassname";
		my $self = {
			%$glass,
			Name => $glassname,
			Maker => q{},
		};
		bless $self, $class;
	}
	sub speak {
		my $self = shift;
		print "Glass";
		print "\n Glass name:     ", $self->name;
		print "\n Glass maker:    ", $self->maker;
		print "\n index:          ", $self->index;
		print "\n abbe number:    ", $self->abbe;
		print "\n";
	}
	sub list_ {
		my $self = shift;
		unless (ref $self) {
			# heder 
			# class method
			my $w = shift;
			my $header = q{};
			$header = shift if (@_);
			printf "\n %10s %13s %10s %11s", "$header","Glass", "Index(d)", "Abbe Number";
			if ((ref $w) eq 'Wavelength'){
				my $wave_names = $w->names_array;
				foreach (@$wave_names){
					my $w_value = $w->value($_);
					if ($_ =~ m/^[0-9\.]+$/ ) {
						printf " %10.3f",$_;
					}
					elsif ($w_value >= 1000){
						printf " %4s(%5d",$_,$w_value;
					}
					else {
						printf " %4s(%5.1f",$_,$w_value;
					}
				}
				printf " %1s", q{};
			}

			return undef;
		}

		my $format = " %10s %13s %10.6f %11.6f";
		printf $format, $self->maker, $self->name, $self->index, $self->abbe;
		if (@_ && $_[0]) {
			my $names;
			if ((ref $_[0]) eq 'Wavelength') {
				my $w = $_[0];
				$names = $w->names_array;
			}
			elsif ((ref $_[0])){
				push(@$names, @$_[0]);
			}
			else {
				push(@$names, @_);
			}
			foreach my $n (@$names) {
				if ($self->index($n)) {
					$self->print_index_with_accuracy(q{ },10,6,q{},$n);
				}
				else {
					printf " %10s", 'undef';
				}
			}
			if ($self->test_idfc == 0 && $self->name ne 'AIR') {
				printf " %1s", q{*};
			}
			else {
				printf " %1s", q{ };
			}
		}
		return $self;
	}

	sub list {
		my $self = shift;
		unless (ref $self) {
			# heder 
			# class method
			my $w = shift;
			my $header = q{};
			$header = shift if (@_);
			my $h = sprintf "\n %10s %13s %10s %11s", "$header","Glass", "Index(d)", "Abbe Number";
			if ((ref $w) eq 'Wavelength'){
				printf "\n %47s", q{};
				my $wave_names = $w->array;
				foreach (@$wave_names){
					my $w_value = $w->value($_);
					printf " %10s",$_;
				}
				print $h;
				foreach (@$wave_names){
					printf " %10.3f",$w->value($_);
				}
				printf " %1s", q{};
			}
			else {
				print $h;
			}

			return undef;
		}

		my $format = " %10s %13s %10.6f %11.6f";
		my $g_maker = $self->maker;
		$g_maker = q{} unless ($g_maker);
		if ($self->index && $self->abbe) {
			printf $format, $g_maker, $self->name, $self->index, $self->abbe;
		}
		elsif ($self->index) {
			$format = " %10s %13s %10.6f %11s";
			printf $format, $g_maker, $self->name, $self->index, q{};
		}
		else {
			$format = " %10s %13s %10s %11s";
			printf $format, $g_maker, $self->name, q{}, q{};
		}
		
		if (@_ && $_[0]) {
			my $names;
			if ((ref $_[0]) eq 'Wavelength') {
				my $w = $_[0];
				$names = $w->names_array;
			}
			elsif ((ref $_[0])){
				push(@$names, @$_[0]);
			}
			else {
				push(@$names, @_);
			}
			foreach my $n (@$names) {
				if ($self->index($n)) {
					#printf " %10.6f", $self->index($n);
					$self->print_index_with_accuracy(q{ },10,6,q{},$n);
				}
				else {
					printf " %10s", 'undef';
				}
			}
			if ($self->test_idfc == 0 && $self->name ne 'AIR') {
				printf " %1s", q{*};
			}
			else {
				printf " %1s", q{ };
			}
		}
		return $self;
	}

	sub name {
		my $self = shift;
		$self->{Name} = shift if (@_);
		$self->{Name};
	}

	sub maker {
		my $self = shift;
		$self->{Maker} = shift  if (@_);
		$self->{Maker};
	}

	sub index {
		my $self = shift;
		my $index = $self->{Index};
		if (@_) {
			my $indeces = $self->indeces;
			$indeces = $self->set_indeces_with_wavelength(@_)->indeces unless ($indeces);
			my $w = shift;
			if ((ref $w) eq 'Wavelength') {
				$index = $$indeces{$w->name}[1];
				delete $$indeces{$w->name} unless ($index);
			}
			elsif ((ref $w)){
				$index = $$indeces{$$w[0]}[1];
				delete $$indeces{$$w[0]} unless ($index);
			}
			elsif ($w) {
				$index = $$indeces{$w}[1];
				delete $$indeces{$w} unless ($index);
			}
		}
		unless ($index) {
			return undef;
		}
		else {
			return $index;
		}
	}

	sub set_nd {
		my $self = shift;
		$self->{Index} = shift;
		return $self;
	}

	sub index_with_accuracy {
		my $self = shift;
		my $index = [$self->{Index},0];
		if (@_) {
			my $indeces = $self->indeces;
			unless ($indeces){
				return undef;
			}
			my $w = shift;
			my $wl = [undef,undef];
			if ((ref $w) eq 'Wavelength') {
				$wl = $$indeces{$w->name};
			}
			elsif ((ref $w)){
				$wl = $$indeces{$$w[0]};
			}
			elsif ($w) {
				$wl = $$indeces{$w};
			}
			if ($$wl[2]) {
				$index = [$$wl[1],$$wl[2]];
			}
			else {
				$index = [$$wl[1],0];
			}
		}
		#use Data::Dumper;print "\nindex_w_a:",$$index[0]," ",$$index[1],"\n";
		return $index;
	}

	sub print_index_with_accuracy {
		my $self = shift;
		my $pref = shift;
		my $f    = shift;
		my $d    = shift;
		my $suff = shift;
		my $i = $self->index_with_accuracy(@_);
		return  unless ($i);
		#print "\nprint_index_with_accuracy pre:$pref f:$f d:$d suff:$suff i:$$i[0],$$i[1]";
		my $accuracy = 0;
		if ($$i[1]) {
			$accuracy = $$i[1];
		}
		elsif (length($$i[0]) < 8 ) {
			$accuracy = 8 - length($$i[0]);
		}
		$f = $f - $accuracy;
		$d = $d - $accuracy;
		foreach (1..$accuracy) {
			$suff = $suff.q{ };
		}
		my $format = sprintf "$pref%s%d.%df$suff",q{%},$f,$d;
		printf $format, $$i[0];
		
		return $self;
	}

	sub set_vd {
		my $self = shift;
		$self->abbe(@_);
		return $self;
	}
	sub abbe {
		my $self = shift;
		$self->{Abbe} = shift  if (@_);
		$self->{Abbe};
	}

	sub etc {
		my $self = shift;
		$self->{Etc} = shift  if (@_);
		$self->{Etc};
	}

	sub indeces {
		my $self = shift;
		$self->{Indeces} = shift if (@_);
		$self->{Indeces};
	}

	sub reset_indeces {
		my $self = shift;
		if (@_) {
			my $new = shift;
			$self->indeces($new);
		}
		else {
			$self->indeces(undef);
		}
		$self->indeces;
	}

	sub set_indeces {
		my $self = shift;
		if (@_){
			my $new_indeces = shift ;
			my @set_names = keys %$new_indeces;
			my $glass_indeces = $self->indeces;
			if ($glass_indeces) {
				foreach my $name (@set_names) {
					$$glass_indeces{$name} = $$new_indeces{$name} unless (exists $$glass_indeces{$name});
				}
				$self->indeces($glass_indeces);
			}
			else {
				$self->indeces($new_indeces);
			}
		}
		return $self;
	}

	sub reset_indeces_from_nd_vd { 
		my $self = shift;
		$self->reset_indeces;
		$self->set_index_from_nd_vd(@_);
		return $self;
	}

	sub set_indeces_from_nd_vd {
		my $self = shift;
		if ((ref $_[0]) eq 'Wavelength') {
			$self->set_indeces($self->indeces_from_nd_vd(@_));
		}
		else {
			my $indeces_from_nd_vd = $self->indeces_from_nd_vd;
			if (@_) {
				my $names;
				#if ((ref $_[0]) eq 'Wavelength') {
				#	$names = $_[0]->names_array;
				#}
				#els
				if ((ref $_[0])) {
					$names = $_[0];
				}
				else {
					push (@$names, @_);
				}
				my $new_indeces;
				foreach my $name (@$names) {
					$$new_indeces{$name} = $$indeces_from_nd_vd{$name} if (exists $$indeces_from_nd_vd{$name});
				}
				$self->set_indeces($new_indeces);
			}
			else {
				$self->set_indeces($indeces_from_nd_vd);
			}
		}
		return $self;
	}

	sub set_idfc {
		my $self = shift;
		$self->index_dispersion_formula_constants(@_);
		return $self;
	}

	sub set_range_of_index_dispersion_formula {
		my $self = shift;
		my $vd = shift;
		$self->range_of_index_dispersion_formula($vd);
		return $self;
	}

	sub range_of_index_dispersion_formula  {
		my $self = shift;
		if (@_) {
			$self->{RangeFormula} = shift;
		}
		if (exists $self->{RangeFormula}){
			return $self->{RangeFormula};
		}
		else {
			return undef;
		}
	}

	sub reset_indeces_with_wavelength {
		my $self = shift;
		$self->reset_indeces;
		$self->set_indeces_with_wavelength(@_);
		return $self;
	}
	sub set_indeces_with_wavelength {
		my $self = shift;
		my $wavelength = shift;
		my $cd = $self->index_dispersion_formula_constants;
		if ($cd && $$cd[0]) {
			if ($$cd[0] eq 'AGF13'){
				$self->set_indeces($self->index_dispersion_formula_hikari9($wavelength));
			}
			elsif ($$cd[0] eq 'AGF12'){
				$self->set_indeces($self->index_dispersion_formula_hikari7($wavelength));
			}
			elsif ($$cd[0] eq 'AGF1'){
				$self->set_indeces($self->index_dispersion_formula($wavelength));
			}
			elsif ($$cd[0] eq 'AGF2' || $$cd[0] =~ m/AGF2.0/) {
				$self->set_indeces($self->index_dispersion_formula_sellmeier($wavelength));
			}
		}
		else {
			$self->set_indeces_from_nd_vd($wavelength);
		}
		my $indeces = $self->indeces;
		unless ($indeces) {
			$self->set_indeces_from_nd_vd($wavelength);
			$indeces = $self->indeces;
		}
		die unless ($indeces);
		return $self;
	}


	sub test_idfc {
		my $self = shift;
		my $cd = $self->index_dispersion_formula_constants;
		if ($cd && $$cd[0]) {
			return 13 if ($$cd[0] eq 'AGF13');
			return 12 if ($$cd[0] eq 'AGF12');
			return 1  if ($$cd[0] eq 'AGF1');
			return 2  if ($$cd[0] eq 'AGF2' || $$cd[0] =~ m/AGF2.0/);
		}
		return 0;
	}

	sub index_dispersion_formula_constants {
		my $self = shift;
		$self->{Coefficient} = shift if (@_);
		unless (exists $self->{Coefficient}){
			return undef;
		}
		$self->{Coefficient};
	}

	sub index_dispersion_formula_sellmeier {
		# OHARA SCHOTT
		my $self = shift;
		my $wavelength = shift;
		my $w_names = $wavelength->names_array;
		my $cd = $self->index_dispersion_formula_constants;
		my $ld = $self->range_of_index_dispersion_formula;
		my $nd = $self->{Index};
		my $index;
		return undef unless ($cd && $$cd[0]);
		return undef if ($$cd[0] ne 'AGF2' && $$cd[0] !~ m/AGF2.0/);
		foreach (0..6) {
			$$cd[$_] = 0 unless $$cd[$_];
		}
		foreach my $name (@$w_names) {
			my $r = $wavelength->value($name) / 1000;
			my $rr = $r**2;
			#            A1                     B1           A2                    B2           A3                      B3
			my $i = ((($$cd[1] * $rr / ($rr - $$cd[2])) + ($$cd[3] * $rr / ($rr - $$cd[4])) + ($$cd[5]  * $rr / ($rr - $$cd[6]))) + 1) **.5;
			if ($r < $$ld[0]) {
				$$index{$name} = [$name,$i,3] if ($i > $nd);
			}
			elsif ($r > $$ld[1]) {
				$$index{$name} = [$name,$i,3] if ($i < $nd && $i > 1);
			}
			else {
				$$index{$name} = [$name,$i] if ($i > 1);
			}
		}
		return $index;
	}

	sub index_dispersion_formula {
		# HOYA, Sumita
		my $self = shift;
		my $wavelength = shift;
		my $w_names = $wavelength->names_array;
		my $cd = $self->index_dispersion_formula_constants;
		my $ld = $self->range_of_index_dispersion_formula;
		my $nd = $self->{Index};
		my $index;
		return undef unless ($cd);
		return undef if ($$cd[0] ne 'AGF1');
		foreach (0..6) {
			$$cd[$_] = 0 unless $$cd[$_];
		}
		foreach my $name (@$w_names) {
			my $r = $wavelength->value($name) / 1000;
			my $i = ($$cd[1] + $$cd[2] * $r**2 + $$cd[3] * $r**-2 + $$cd[4] * $r**-4 + $$cd[5] * $r**-6 + $$cd[6] * $r**-8) **.5;
			if ($r < $$ld[0]) {
				$$index{$name} = [$name,$i,3] if ($i > $nd);
			}
			elsif ($r > $$ld[1]) {
				$$index{$name} = [$name,$i,3] if ($i < $nd && $i > 1);
			}
			else {
				$$index{$name} = [$name,$i] if ($i > 1);
			}
		}
		return $index;
	}

	sub index_dispersion_formula_hikari7 {
		# HIKARI 
		my $self = shift;
		my $wavelength = shift;
		my $w_names = $wavelength->names_array;
		my $cd = $self->index_dispersion_formula_constants;
		my $ld = $self->range_of_index_dispersion_formula;
		my $nd = $self->{Index};
		my $index;
		return undef unless ($cd);
		return undef if ($$cd[0] ne 'AGF12');
		foreach (0..7) {
			$$cd[$_] = 0 unless $$cd[$_];
		}
		foreach my $name (@$w_names) {
			my $r = $wavelength->value($name) / 1000;
			my $i = ($$cd[1] + $$cd[2] * $r**2 + $$cd[3] * $r**-2 + $$cd[4] * $r**-4 + $$cd[5] * $r**-6 + $$cd[6] * $r**-8 + $$cd[7] * $r**4) **.5;
			if ($r < $$ld[0]) {
				$$index{$name} = [$name,$i,3] if ($i > $nd);
			}
			elsif ($r > $$ld[1]) {
				$$index{$name} = [$name,$i,3] if ($i < $nd && $i > 1);
			}
			else {
				$$index{$name} = [$name,$i] if ($i > 1);
			}
		}
		return $index;
	}

	sub index_dispersion_formula_hikari9 {
		# HIKARI NEW GLASS
		my $self = shift;
		my $wavelength = shift;
		my $w_names = $wavelength->names_array;
		my $cd = $self->index_dispersion_formula_constants;
		my $ld = $self->range_of_index_dispersion_formula;
		my $nd = $self->{Index};
		my $index;
		return undef unless ($cd);
		return undef if ($$cd[0] ne 'AGF13');
		foreach (0..9) {
			$$cd[$_] = 0 unless $$cd[$_];
		}
		foreach my $name (@$w_names) {
			my $r = $wavelength->value($name) / 1000;
			my $i = ($$cd[1] + $$cd[2] * $r**2 + $$cd[3] * $r**4 + $$cd[4] * $r**-2 + $$cd[5] * $r**-4 + $$cd[6] * $r**-6 + $$cd[7] * $r**-8 + $$cd[8] * $r**-10 + $$cd[9] * $r**-12) **.5;
			if ($r < $$ld[0]) {
				$$index{$name} = [$name,$i,3] if ($i > $nd);
			}
			elsif ($r > $$ld[1]) {
				$$index{$name} = [$name,$i,3] if ($i < $nd && $i > 1);
			}
			else {
				$$index{$name} = [$name,$i] if ($i > 1);
			}
		}
		return $index;
	}

	sub indeces_from_nd_vd {
		my $self = shift;
		my $nd = $self->index;
		my $vd = $self->abbe;
		my $index;

		if ($vd && $vd != 0){
			my @a = qw/-0.0000583850240651572 -0.0000072362389179955 -0.00000857041520043334 0.0000318533097940724 
			            0.0000390840876470875  0.0000488921337348262  0.00017607838239413
			            0.00000107034178228145 0.00000335206345471141 0.0000322443634205704
			            0.000058555712032351500  0.000013897095987490700/;
			my @b = qw/ 0.00963062864477342    0.00114895547270874    0.00134945596551881   -0.00488347374582586  
			           -0.00603177936127578   -0.00735206734664444   -0.0267015534159699
			            0.000667885809865637   0.000727674251657583   0.00453596687778952
			            0.00548118401740362    0.00127614144999278/;
			my @c = qw/ 0.455082920643784      0.261774306273274      0.493084062868116      0.71998657703516      
			            1.45818772107994       0.713222567189907      2.17820279075923
			            0.0320256732063829     0.0368321510326376     0.13574120129307
			            0.0743976977850314     0.00947589847118399/;

			#y = 0.000013897095987490700 x2 + 0.001276141449992780000 x + 0.009475898471183990000 
			#y = 0.000058555712032351500 x2 + 0.005481184017403620000 x + 0.074397697785031400000 
			#y = 0.000032244363420570400 x2 + 0.004535966877789520000 x + 0.135741201293070000000 
			#y = 0.000003352063454711410 x2 + 0.000727674251657583000 x + 0.036832151032637600000 
			#y = 0.000001070341782281450 x2 + 0.000667885809865637000 x + 0.032025673206382900000 

			# y = (nX1-nX2)/(nF-nC) = a x^2 + b x + c;
			my $yt = $a[0] * $vd * $vd + $b[0] * $vd + $c[0]; #C-t/F-C
			my $yc = $a[1] * $vd * $vd + $b[1] * $vd + $c[1]; #d-C/F-C
			my $ye = $a[2] * $vd * $vd + $b[2] * $vd + $c[2]; #e-C/F-C

			my $yf = $a[3] * $vd * $vd + $b[3] * $vd + $c[3]; #g-F/F-C
			my $yg = $a[4] * $vd * $vd + $b[4] * $vd + $c[4]; #g-d/F-C
			my $yh = $a[5] * $vd * $vd + $b[5] * $vd + $c[5]; #h-g/F-C
			my $yi = $a[6] * $vd * $vd + $b[6] * $vd + $c[6]; #i-g/F-C

			my $y1064 = $a[7] * $vd * $vd + $b[7] * $vd + $c[7];    #t-1064/F-C
			my $y1129 = $a[8] * $vd * $vd + $b[8] * $vd + $c[8];    #1064-1129/F-C
			my $y1530 = $a[9] * $vd * $vd + $b[9] * $vd + $c[9];    #1129-1530/F-C
			my $y1970 = $a[10] * $vd * $vd + $b[10] * $vd + $c[10]; #1530-1970 /F-C
			my $y2058 = $a[11] * $vd * $vd + $b[11] * $vd + $c[11]; #1970-2058/F-C			

			my $nc = $nd - $yc * ($nd -1) / $vd; #d-C/F-C
			my $ng = $nd + $yg * ($nd -1) / $vd; #g-d/F-C

			my $nt = $nc - $yt * ($nd -1) / $vd; #C-t/F-C
			my $ne = $nc + $ye * ($nd -1) / $vd; #e-C/F-C

			my $nf = $ng - $yf * ($nd -1) / $vd; #g-F/F-C

			my $nh = $ng + $yh * ($nd -1) / $vd; #h-g/F-C
			my $ni = $ng + $yi * ($nd -1) / $vd; #i-g/F-C

			my $n1064 = $nt - $y1064 * ($nd -1) / $vd; 
			my $n1129 = $n1064 - $y1129 * ($nd -1) / $vd; 
			my $n1530 = $n1129 - $y1530 * ($nd -1) / $vd; 
			my $n1970 = $n1530 - $y1970 * ($nd -1) / $vd; 
			my $n2058 = $n1970 - $y2058 * ($nd -1) / $vd; 

			$index = {
				'2058'=>[2058.09, $n2058,2],
				'1970'=>[1970.09, $n2058,2],
				'1530'=>[1529.582,$n2058,2],
				'1129'=>[1128.64, $n2058,2],
				'1064'=>[1064.14, $n2058,2],
				t=>[Wavelength->wavelength('t'),$nt,2],
				C=>[Wavelength->wavelength('C'),$nc,1],
				d=>[Wavelength->wavelength('d'),$nd,0],
				e=>[Wavelength->wavelength('e'),$ne,1],
				F=>[Wavelength->wavelength('F'),$nf,1],
				g=>[Wavelength->wavelength('g'),$ng,1],
				h=>[Wavelength->wavelength('h'),$nh,2],
				i=>[Wavelength->wavelength('i'),$ni,2],
			};
			if ((ref $_[0]) eq 'Wavelength') {
				my $wavelength = $_[0];
				my $names = $wavelength->names_array;
				my @u = ();
				foreach my $name (@$names) {
					if (
						$name ne '2058' && 
						$name ne '1970' && 
						$name ne '1530' && 
						$name ne '1129' && 
						$name ne '1064' && 
						$name ne 't' && 
						$name ne 'C' &&  
						$name ne 'd' && 
						$name ne 'e' && 
						$name ne 'F' &&  
						$name ne 'g' && 
						$name ne 'h' && 
						$name ne 'i' 
						) {
						push (@u, $name);
					}

				}
				my $w = [
					Wavelength->wavelength('i'),
					Wavelength->wavelength('h'),
					Wavelength->wavelength('g'),
					Wavelength->wavelength('F'),
					Wavelength->wavelength('e'),
					Wavelength->wavelength('d'),
					Wavelength->wavelength('C'),
					Wavelength->wavelength('t'),
					1064.14,
					1128.64,
					1529.582,
					1970.09,
					2058.09
					];
				my $i = [
					$ni,
					$nh,
					$ng,
					$nf,
					$ne,
					$nd,
					$nc,
					$nt,
					$n1064,
					$n1129,
					$n1530,
					$n1970,
					$n2058,
					];

				if ($#u > -1){
					foreach (@u) {
						my $user_wl = $wavelength->wavelength($_);
						my $new_w;
						my $accuracy = 1;
						if ($user_wl > 5000) {
							$new_w = undef;
						}
						elsif ($user_wl < 320){
							$new_w = undef;
						}
						else {
							$new_w = $self->spline($w,$i,$user_wl);
						}
						$accuracy = $accuracy + 1 if ($user_wl < Wavelength->wavelength('h'));
						$accuracy = $accuracy + 1 if ($user_wl < Wavelength->wavelength('i'));
						$accuracy = $accuracy + 1 if ($user_wl > Wavelength->wavelength('C'));
						#$accuracy = $accuracy + 1 if ($user_wl > Wavelength->wavelength('t'));
						$accuracy = $accuracy + 1 if ($user_wl > 2058);
						$$index{$_}=[$user_wl,$new_w,$accuracy];
					}
				}
				my $new_indeces;
				foreach my $name (@$names) {
					$$new_indeces{$name} = $$index{$name};
				}
				$index = $new_indeces;
			}
		}
		else {
			if ((ref $_[0]) eq 'Wavelength') {
				my $wavelength = $_[0];
				my $names = $wavelength->names_array;
				foreach my $name (@$names) {
					$$index{$name}=[$wavelength->wavelength($name),$nd];
				}
			}
			else {
				$index = {
					C=>[Wavelength->wavelength('C'),$nd],
					d=>[Wavelength->wavelength('d'),$nd],
					e=>[Wavelength->wavelength('e'),$nd],
					F=>[Wavelength->wavelength('F'),$nd],
					g=>[Wavelength->wavelength('g'),$nd],
				};
			}
		}
		return $index;
	}

	sub spline {
		# http://www.sist.ac.jp/~suganuma/kougi/other_lecture/SE/num/num.htm#7.2
		my $self = shift;
		my $rx = shift;
		my $ry = shift;

		my @x = (@$rx);
		my @y = (@$ry);

		my $x = shift;

		if ($x[0]>$x[$#x]) {
			use Data::Dumper; print STDERR "\n spline", Dumper ($rx, $ry, $x);
			@x = reverse(@x);
			@y = reverse(@y);
		}

		# step1
		my @h = ();
		my @b = (undef);
		my @d = (undef);
		my $n = $#x;

		foreach my $i (0..$n-1) {
			push (@h,$x[$i+1]-$x[$i]);
		}
		foreach my $i (1..$n-1) {
			my $b = 2*($h[$i]+$h[$i-1]);
			$b[$i] = $b;
		}
		foreach my $i (1..$n-1) {
			my $d = 3*(($y[$i+1] - $y[$i])/$h[$i]-($y[$i] - $y[$i-1])/$h[$i-1]);
			$d[$i] = $d;
		}
		# step2
		#return undef unless ($b[1]);
		my @g = (undef,1E14);
		my @u = (undef,1E14);
		if ($b[1] && $b[1] != 0) {
			@g = (undef,$h[1]/$b[1]);
			@u = (undef,$d[1]/$b[1]);
		}

		foreach my $i (2..$n-2) {
			my $g = $h[$i]/($b[$i]-$h[$i-1]*$g[$i-1]);
			push (@g, $g);
		}
		for my $i (2..$n-1) {
			my $u = ($d[$i]-$h[$i-1]*$u[$i-1])/($b[$i]-$h[$i-1]*$g[$i-1]);
			push (@u, $u);
		}
		# step3
		my @r = ();
		$r[$n-1]=$u[$n-1];
		my @test = ($n-1);
		for (my $i = $n-2; $i >= 1; $i--){
			$r[$i] = $u[$i]-$g[$i]*$r[$i+1];
		}
		$r[0]=0;

		# step4
		my $i = 0;
		foreach (1..$#x-2) {
			last if ($x[$i] > $x);
			$i++;
		}		
		my $xx = ($x-$x[$i]);
		my $pi = $y[$i];
		my $qi = ($y[$i+1]-$y[$i])/$h[$i]-$h[$i]*($r[$i+1]+2*$r[$i])/3;
		my $si = ($r[$i+1]-$r[$i])/(3*$h[$i]);
		my $y = $pi+$qi*$xx+$r[$i]*$xx*$xx+$si*$xx*$xx*$xx;
		return $y;
	}

	sub dump {
		my $self = shift;
		use Data::Dumper;
		my $dumper_data = Data::Dumper->Dump([$self],["GLASS"]);
		print $dumper_data;
		return $self;
	}

	sub svg_fill {
		my $self = shift;
		my $b = (2.5 - $self->index)/(2.5 - 1.4)*70+180;
		my $g = (2.5 - $self->index) / (2.5 - 1.4)*150 + ($self->abbe - 20) /  (100 - 20)*100;
		my $r = (2.5 - $self->index) / (2.5 - 1.4)*90 + (100 - $self->abbe) /  (100 - 20)*90;
		#$g = 150;
		my $glass_color = sprintf "rgb(%03d,%03d,%03d)",$r,$g,$b;
		return $glass_color;
	}

	sub TO_JSON               
	{
		#http://d.hatena.ne.jp/koizuss/20090605/1244174060
		my $self = shift;
		my %h_self = map { $_ => $self->{$_} } keys(%$self);

		# インスタンスをhashに変換

		return { ref($self) => \%h_self };    # パッケージ名を付与して返却
	}

	sub bless_hash { #Glass
		my $class = shift;
		my $hash = shift;
		#$hash = $hash->{Glass};
		#use Data::Dumper;
		#print Dumper($hash);
		#return $class;
		bless $hash, $class;
	}
	1;
}

{ package Air;
	# ONO Hiroki onohiroki@cup.com 
	# open source project
	use strict;
	use warnings;
	@Air::ISA = qw(Glass);
	my $air;	
	BEGIN {
		my $self = {
			Name => q{AIR},
			Maker => q{},
			Index => 1,
			Abbe => 0,
			Coefficient => [],
			Etc => [],
		};
		$air = bless $self,__PACKAGE__;
	}
	sub new {
		$air;
	}
	sub get {
		$air;
	}
	sub name {
		$_[0]->{Name};
	}
	sub maker {
		$_[0]->{Maker};
	}
	sub index {
		$_[0]->{Index};
	}
	sub abbe {
		$_[0]->{Abbe};
	}
	sub svg_fill {
		my $self = shift;
		return "rgb(255,255,255)";
	}
	sub TO_JSON               
	{
		#http://d.hatena.ne.jp/koizuss/20090605/1244174060
		my $self = shift;
		my %h_self = map { $_ => $self->{$_} } keys(%$self);

		# インスタンスをhashに変換

		return { ref($self) => \%h_self };    # パッケージ名を付与して返却
	}
	1;
}

{ package NotFound;
	# ONO Hiroki onohiroki@cup.com 
	# open source project
	use strict;
	use warnings;
	@NotFound::ISA = qw(Air);
	sub new {
		my $class = shift;
		my $self = {
			Name => 'NotFound',
			Maker => 'NotFound',
			Index => 1,
			Abbe => 0,
			Coefficient => [],
			Etc => [],
		};
		bless $self, $class;
	}
	1;
}
{ package GlassCatalog;
	# ONO Hiroki onohiroki@cup.com 
	# open source project
	use strict;
	use warnings;
	sub new {
		my $class = shift;
		my $glass_catalog = {};
		my $self = {
			GlassCatalog => $glass_catalog,
			Wavelength => undef,
		};
		bless $self, $class;
	}
	sub new_with_dumped_data {
		my $class = shift;
		my $dumped_data = shift;
		my $VAR1;
		eval($dumped_data) if ($dumped_data);
		unless ($VAR1) {
			my $glass_catalog = {};
			my $self = {
				GlassCatalog => $glass_catalog,
				Wavelength => undef,
			};
			bless $self, $class;
		}
		else{
			return $VAR1;
		}
	}

	sub add_new_glass {
		my $self = shift;
		my $name = shift;
		my $maker = shift;
		my $glass_catalog = $self->{GlassCatalog};
		my $new_glass = Glass->new($name,$maker,@_) ;
		if (exists $$glass_catalog{$maker}{$name}){
			return $$glass_catalog{$maker}{$name};
		}
		elsif (exists $$glass_catalog{$maker}) {
			my $glasses = $$glass_catalog{$maker};
			$$glasses{$name} = $new_glass;
		}
		else {
			$$glass_catalog{$maker} = { $name => $new_glass };
		}
		return $$glass_catalog{$maker}{$name};
	}

	sub add_glass {
		my $self = shift;
		my $glass = shift;
		my $name = $glass->name;
		my $maker = $glass->maker;
		$maker = q{} unless ($maker);
		my $glass_catalog = $self->{GlassCatalog};
		if (exists $$glass_catalog{$maker}{$name}){
			$glass = undef;
			return $$glass_catalog{$maker}{$name};
		}
		elsif (exists $$glass_catalog{$maker}) {
			my $glasses = $$glass_catalog{$maker};
			$$glasses{$name} = $glass;
		}
		else {
			$$glass_catalog{$maker} = { $name => $glass };
		}
		return $glass;
	}

	sub replace_glass {
		my $self = shift;
		my $glass = shift;
		my $name = $glass->name;
		my $maker = $glass->maker;
		my $glass_catalog = $self->{GlassCatalog};
		$$glass_catalog{$maker} = { $name => $glass };
		return $self;
	}

	sub glass {
		my $self = shift;
		my $name = shift;
		my $maker = q{};
		$maker = shift if(@_);
		my $glass_catalog = $self->{GlassCatalog};
		my @k = keys %$glass_catalog;
		#@k = ($maker) if ($maker && $maker ne q{});
		foreach my $key (@k) {
			if (exists $$glass_catalog{$key}{$name}) {
				return $$glass_catalog{$key}{$name}
			}
		}
		return NotFound->new;
	}

	sub concat {
		my $self = shift;
		my $glass_catalog = shift;	
		my @k = keys %$glass_catalog;
		my $hash = {};
		foreach my $maker (@k) {
			my @glass_cat_m = $$glass_catalog{$maker};
			foreach my $g (@glass_cat_m) {
				my @glass_name = keys %$g;
				foreach my $gname (@glass_name){
					$self->add_glass($$g{$gname});
				}
			}
		}
		return $self;
	}

	sub find_glass_by_name {
		my $self = shift;
		my $find = shift;
		my $maker = q{};
		$maker = shift if(@_);
		my $glass_catalog = $self->{GlassCatalog};
		my $new_glass_catalog = GlassCatalog->new;
		my @k = keys %$glass_catalog;
		@k = ($maker) if ($maker ne q{});
		foreach my $key (@k) {
			my @names = keys %{$$glass_catalog{$key}};
			foreach my $name (@names){
				if ($name =~ m/$find/i){
					$new_glass_catalog->add_glass($$glass_catalog{$key}{$name});
				}
			}
		}
		return $new_glass_catalog;
	}

	sub order {
		my $self = shift;
		if (@_) {
			$self->{Order} = shift;
		}
		if (exists $self->{Order}) {
			return $self->{Order}
		}
		else {
			return [];
		}
	}

	sub set_order_by_surfaces {
		my $self = shift;
		my $surfaces = shift;
		#my %glass_names;
		my @order;
		foreach my $s (@$surfaces) {
			my $maker = $s->glass->maker;
			my $name = $s->glass->name;
			next if ((ref $s->glass) ne 'Glass');
			#unless (exists ${$glass_names{$maker}}{$name}) {
			#	push(@order, [$name,$maker]) if ($name ne 'NotFound');
			#	$glass_names{$maker} = {$name => 1};
			#}
			push(@order, [$name,$maker]);
		}
		$self->order(\@order);
		return $self;
	}

	sub list {
		my $self = shift;	
		my $maker = q{};
		my $mode = 'GlassCatalog';
		my $order = undef;
		my $glass_catalog = $self->{GlassCatalog};
		my @k = keys %$glass_catalog;
		if ($_[0] && $_[0] =~ m/Lens/i){
			$mode = 'Lens';
		}
		elsif (@_) {
			@k = @_;
		}
		my $wavelength = $self->wavelength;
		print STDERR "\n",(ref $self),"::list ERROR $wavelength" unless ((ref $wavelength) eq 'Wavelength');
		if (@{$wavelength->names_array} < 2 && ${$wavelength->names_array}[0] eq 'd'){
			$wavelength = undef;
		}
		if ($mode eq 'Lens') {
			Glass->list($wavelength);
			print "\n";
			my $order = $self->order;
			foreach my $g_name_maker (@$order) {
				$self->glass($$g_name_maker[0],$$g_name_maker[1])->list($wavelength);
				print "\n";
			}
		}
		else {
			foreach my $key (@k) {
				print "\nCATALOG: $key\n";
				if ($wavelength) {
					Glass->list($wavelength);
				}
				else {
					Glass->list;
				}
				print "\n";
				my @glass_cat_m = $$glass_catalog{$key};
				foreach my $g (@glass_cat_m) {
					my @glass_name = keys %$g;
					foreach my $gname (@glass_name){
						if ($wavelength) {
							$$g{$gname}->list($wavelength);
						}
						else {
							$$g{$gname}->list;
						}
						print "\n";
					}
				}
			}
		}
		return $self;
	}

	sub test_index_dispersion_formula {
		my $self = shift;	
		my $mode = 'GlassCatalog';
		my $glass_catalog = $self->{GlassCatalog};
		my @k = keys %$glass_catalog;
		my $hash = {};
		Glass->list;
		print "\n";
		foreach my $maker (@k) {
			my @glass_cat_m = $$glass_catalog{$maker};
			foreach my $g (@glass_cat_m) {
				my @glass_name = keys %$g;
				foreach my $gname (@glass_name){
					$$g{$gname}->list;
					my $cd = $$g{$gname}->index_dispersion_formula_constants;
					print " ";
					print join(" ", @$cd);
					print "\n";
				}
			}
		}
		return $hash;
	}

	sub create_cv_glassname_hash {
		my $self = shift;	
		my $mode = 'GlassCatalog';
		my $glass_catalog = $self->{GlassCatalog};
		my @k = keys %$glass_catalog;
		my $hash = {};
		foreach my $maker (@k) {
			my @glass_cat_m = $$glass_catalog{$maker};
			foreach my $g (@glass_cat_m) {
				my @glass_name = keys %$g;
				foreach my $gname (@glass_name){
					my $cv_name = uc $gname;
					my $cv_maker = uc $maker;
					$cv_name =~ s/[^A-Z0-9]//g;
					$$hash{$cv_name.q{_}.$cv_maker} = $gname;
				}
			}
		}
		return $hash;
	}

	sub keys_glass_name {
		my $self = shift;	
		my $mode = 'GlassCatalog';
		my $glass_catalog = $self->{GlassCatalog};
		my @k = keys %$glass_catalog;
		my @glass_name = ();
		foreach my $maker (@k) {
			my @glass_cat_m = $$glass_catalog{$maker};
			foreach my $g (@glass_cat_m) {
				my @gnames = keys %$g;
				push (@glass_name,@gnames);
			}
		}
		return \@glass_name;
	}

	sub glass_makers {
		my $self = shift;
		my $glass_catalog = $self->{GlassCatalog};
		my @k = keys %$glass_catalog;
		return \@k;
	}

	sub wavelength {
		my $self = shift;
		if (@_) {
			if ((ref $_[0]) ne 'Wavelength') {
				print STDERR "\n",(ref $self),"::wavelength Error. ";
			}
			unless ($_[0]->array ) {
				print STDERR "\n",(ref $self),"::wavelength Error about names array. ";
			}
			unless ($_[0]->bundle ) {
				print STDERR "\n",(ref $self),"::wavelength Error about bundle hash. ";
				print  "\n",(ref $self),"::wavelength Error about bundle hash. ";
				use Data::Dumper;print "\n",(ref $self),"::wavelength",Dumper (@_);
				die;
			}
			use Data::Dumper;
			$self->{Wavelength} = shift;
		}
		my $w = $self->{Wavelength};
		$w = Wavelength->new->by_names('d') unless ($w);
		return $w;
	}

	sub set_wavelength {
		my $self = shift;
		if (@_) {
			if ((ref $_[0]) eq 'Wavelength') {
				$self->wavelength($_[0]);
			}
			else {
				$self->wavelength(Wavelength->new->by_names(@_));
			}
		}
		else {
			$self->wavelength(Wavelength->new->by_names('C','d','F','g'));
		}
		return $self;
	}

	sub set_indeces {
		my $self = shift;
		my $glass_catalog = $self->{GlassCatalog};
		my $w = $self->wavelength;
		if (@_ && $_[0]) {
			if ((ref $_[0]) eq 'Wavelength') {
				$w = $_[0];
				$self->set_wavelength($w);
			}
			else {
				$self->set_wavelength(@_);
				$w = $self->wavelength;
			}
		}
		my @k = keys %$glass_catalog;
		foreach my $key (@k) {
			my @glass_cat_m = $$glass_catalog{$key};
			foreach my $g (@glass_cat_m) {
				my @glass_name = keys %$g;
				foreach my $gname (@glass_name){
					#use Data::Dumper;print Dumper($w);
					#$$g{$gname}->set_indeces_from_nd_vd(@{$w->names_array});
					$$g{$gname}->set_indeces_with_wavelength($w);
				}
			}
		}
		return $w;
	}

	sub save_dump {
		my $self = shift;
		my $glass_catalog = $self->{GlassCatalog};
		delete($$glass_catalog{q{}});
		my $filename = "dumped_glass_catalog_data.txt";
		$filename = shift if (@_);
		$filename =~ s/\s//gi;
		$filename =~ s/\:/_/gi;
		$filename =~ s/\\/_/gi;
		$filename =~ s/\,/_/gi;
		open DUMPFILE, ">$filename"
			or return "ERROR $!";
		use Data::Dumper;
		print DUMPFILE Dumper($self);
		close DUMPFILE;
		return "Saved as $filename";
	}

	sub dump {
		my $self = shift;
		use Data::Dumper;
		my $dumper_data = Data::Dumper->Dump([$self],["GLASS_CATALOG_DATA"]);
		print Dumper($dumper_data);
		return $self;
	}

	sub TO_JSON               
	{
		#http://d.hatena.ne.jp/koizuss/20090605/1244174060
		my $self = shift;
		my %h_self = map { $_ => $self->{$_} } keys(%$self);

		# インスタンスをhashに変換

		return { ref($self) => \%h_self };    # パッケージ名を付与して返却
	}
	1;
}



