{ package GlassAGF;
	# ONO Hiroki onohiroki@cup.com 
	# http://www.opensource.org/licenses/bsd-license
	# Copyright (c) 2011, ONO Hiroki onohiroki@cup.com 
	# All rights reserved.
	use strict;
	use warnings;
	sub read {
		my $self = shift;
		my $agf_glass_catalog = GlassCatalog->new;
		my @makers = qw/HOYA CDGM HIKARI PILKINGTON SCHOTT CORNFR SUMITA CHANCE OHARA CHINA/;
		my @files = <*.agf>;
		foreach my $agf (@files) {
			my ($maker, $glass_name, $index, $vvalue,$idfc,$co_type,$vd) = (q{},q{},1,0,undef,undef,undef);
			open AGFFILE, "<$agf";
			print "\nopen $agf ";
			$maker = $agf;
			$maker =~ s/ZEMAX//gi;
			$maker =~ s/\.agf//gi;
			$maker =~ s#.*/##g;
			$maker =~ s/[^a-zA-Z]//g;
			$maker = uc $maker;
			while (<AGFFILE>) {
				chomp;
				if (m/^\s*CC (.*)/) {
					my $header = $1;
					foreach my $m (@makers) {
						if ("$maker $header" =~ m/$m/i ) {
							$maker = $m;
							last;
						}
					}
					print $maker;
				}
				if (m/^NM (.+)$/) {
					my @line = split /\s+/, $1;
					if ($glass_name =~ m/[A-Z0-9]/i ) {
						my $glass = Glass->new($glass_name,$maker,$index,$vvalue);
						if ($idfc) {
							unshift (@$idfc,"AGF$co_type");
							$glass->set_idfc($idfc);
							if ($vd) {
								$glass->set_range_of_index_dispersion_formula($vd);
							}
						}
						$agf_glass_catalog->add_glass($glass);
					}
					$glass_name = $line[0];	
					$co_type = $line[1];
					$index = $line[3];
					$vvalue = $line[4];
					$idfc=undef;
					$vd=undef;
					print "\n TYPE: $co_type  GLASS:$glass_name Maker:$maker" 
						unless ($co_type == 2 || $co_type == 1 || $co_type == 13 || $co_type == 12);
				}
				if (m/^CD (.*)$/) {
					@$idfc = split /\s+/, $_;
					shift @$idfc;
				}
				if (m/^LD (.*)$/) {
					@$vd = split /\s+/, $_;
					shift @$vd;
				}
			}
			my $glass = Glass->new($glass_name,$maker,$index,$vvalue);
			$glass->set_idfc($idfc) if ($idfc);
			$agf_glass_catalog->add_glass($glass);
		}
		delete($$agf_glass_catalog{q{}});
		return $agf_glass_catalog;
	}
	1;
}