#!/usr/bin/perl
use strict;
use warnings;
use lib "./lib";
use Lens;

my $cv_glass_macro_data_catalog = GlassCatalog->new;

my ($cat, $glass, $index, $vvalue) = (q{},q{},1,0);

my @cv_glass_macro_data_files = <*.dat>;
foreach my $dat (@cv_glass_macro_data_files) {
	open DATFILE, "<$dat";
	my $head = <DATFILE>;
	next if ($head !~ m/Catalog	Glass	Index	V-value	NF-NC	DPF	Price	Avail	Bubble	Stain/);
	while (<DATFILE>) {
		if (m/(\w+)\t([^\s]+)\t([^\s]+)\t([^\s]+)/) {
			$cat = $1;
			$glass = $2;
			$index = $3;
			$vvalue = $4;
			$cv_glass_macro_data_catalog->add_new_glass($glass,$cat,$index,$vvalue);
		}
	}
}
$cv_glass_macro_data_catalog->list;
$cv_glass_macro_data_catalog->save_dump("CVGLASS");


